Index: sys/modules/dtrace/Makefile
===================================================================
--- sys/modules/dtrace/Makefile	(revision 253401)
+++ sys/modules/dtrace/Makefile	(working copy)
@@ -26,4 +26,9 @@
 SUBDIR+=	systrace_freebsd32
 .endif
 
+_INVARIANTS_ENABLED!= grep INVARIANTS ${KERNBUILDDIR}/opt_global.h || true
+.if !empty(_INVARIANTS_ENABLED)
+CFLAGS += -DDEBUG
+.endif
+
 .include <bsd.subdir.mk>
Index: sys/modules/opensolaris/Makefile
===================================================================
--- sys/modules/opensolaris/Makefile	(revision 253401)
+++ sys/modules/opensolaris/Makefile	(working copy)
@@ -24,6 +24,11 @@
 		-I${.CURDIR}/../../cddl/contrib/opensolaris/uts/common	\
 		-I${.CURDIR}/../..
 
+_INVARIANTS_ENABLED!= grep INVARIANTS ${KERNBUILDDIR}/opt_global.h || true
+.if !empty(_INVARIANTS_ENABLED)
+CFLAGS += -DDEBUG
+.endif
+
 IGNORE_PRAGMA=	1
 
 .include <bsd.kmod.mk>
Index: sys/modules/zfs/Makefile
===================================================================
--- sys/modules/zfs/Makefile	(revision 253401)
+++ sys/modules/zfs/Makefile	(working copy)
@@ -91,8 +91,10 @@
 CFLAGS+=-mminimal-toc
 .endif
 
-#CFLAGS+=-DDEBUG=1
-#DEBUG_FLAGS=-g
+_INVARIANTS_ENABLED!= grep INVARIANTS ${KERNBUILDDIR}/opt_global.h || true
+.if !empty(_INVARIANTS_ENABLED)
+CFLAGS += -DDEBUG
+.endif
 
 .include <bsd.kmod.mk>
 